/* Agent Library Common

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF

*/

#include <stddef.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "agent_lib.h"
#include "actuate.h"

uint8_t act_series[]={                                                          // ACTp^̔z
    0b00101010
   ,0b00000000
   ,0b00110110
   ,0b00000000
   ,0b00010101
   ,0b00000000
};
uint8_t act_id =0;                                                              // ACTp^̃CfbNX
uint8_t* act_get =NULL;                                                         // ACTp^i|C^j
extern uint8_t rhythm_source;                                                   // Y\[X

// xNgFXCb`iPB1/PCINT9j
ISR (PCINT1_vect) {
    
    if (BIT_CHECK(PCINT9_PIN, PCINT9_BIT)) {
        return;                                                                 // PCINT9 ͖
    }
    
    switch (rhythm_source) {
    case SWITCH_TRG:
        act_get = get_act();                                                    // ACT擾
        break;
    case TIMER_TRG:
        // WDTG~ȂnCғȂ~
        if (WDTCSR == 0x00) {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = _WDT_INTERRUPT | _WDT_500MS;                               // WDT MODE , PRESCALER
        }
        else {
            RESET_WDT;                                                          // WDT Zbg    wdt_reset();
            WDTCSR |= _WDT_CHANGE;                                              // WDT ݒύXiFύXO̕K{j
            WDTCSR = 0x00;                                                      // WDT ~
        }
        break;
    }

}

// xNgFWatch Dog Timer
ISR (WATCHDOG_vect) {
    act_get = get_act();                                                        // ACT擾
}

// ACT擾
//mߒlnACTp^
uint8_t* get_act(void) {
    uint8_t *act_temp;

    act_temp = &act_series[act_id];                                             // ACT擾
    if (++act_id >= sizeof(act_series)) act_id = 0;                             // ACTXVizؑցj
    
    return act_temp;
}
